 /**
 * regtable.h
 *
 * Author: Alberto Pelarda
 * Creation date: 01/04/2016
 */

#ifndef _REGTABLE_H
#define _REGTABLE_H

#include "Arduino.h"
#include "register.h"
#include "commonregs.h"

#include "define_device_io.h"

/**
 * Register indexes
 */
DEFINE_REGINDEX_START()
//-------------------------------------------------------------

  REG_IO_00,
  REG_IO_01,
  REG_IO_02,
  REG_IO_03,
  REG_IO_04,
  REG_IO_05,
  REG_IO_06,
  REG_IO_07,
  REG_IO_08,
  REG_IO_09,
  REG_IO_10,
  REG_IO_11,
  REG_IO_12,
  REG_IO_13,
  REG_IO_14,
  REG_IO_15,
  
DEFINE_REGINDEX_END()

/**
 * Definition of I/O states data 
 */
byte io_state_data_00[1];
byte io_state_data_01[1];
byte io_state_data_02[1];
byte io_state_data_03[1];
byte io_state_data_04[1];
byte io_state_data_05[1];
byte io_state_data_06[1];
byte io_state_data_07[1];
byte io_state_data_08[1];
byte io_state_data_09[1];
byte io_state_data_10[1];
byte io_state_data_11[1];
byte io_state_data_12[1];
byte io_state_data_13[1];
byte io_state_data_14[1];
byte io_state_data_15[1];

/**
 * t_io_data : Type of data for I/O information
 */
typedef struct
{
  int reg_type;  // Register type ( BINARY_INPUT / BINARY_OUTPUT / ANALOG_INPUT / PWM_OUTPUT )
  byte* data;    // Information of the stat of the I/O
}t_io_data;

/**
 * io_data : Table to acces I/O information for every pin
 */
t_io_data io_data[]=
{
  { IO_PORT00, &io_state_data_00[0]},
  { IO_PORT01, &io_state_data_01[0]},
  { IO_PORT02, &io_state_data_02[0]},
  { IO_PORT03, &io_state_data_03[0]},
  { IO_PORT04, &io_state_data_04[0]},
  { IO_PORT05, &io_state_data_05[0]},
  { IO_PORT06, &io_state_data_06[0]},
  { IO_PORT07, &io_state_data_07[0]},
  { IO_PORT08, &io_state_data_08[0]},
  { IO_PORT09, &io_state_data_09[0]},
  { IO_PORT10, &io_state_data_10[0]},
  { IO_PORT11, &io_state_data_11[0]},
  { IO_PORT12, &io_state_data_12[0]},
  { IO_PORT13, &io_state_data_13[0]},
  { IO_PORT14, &io_state_data_14[0]},
  { IO_PORT15, &io_state_data_15[0]},
};

#endif

